#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef __TURBOC__
	#include <mem.h>
	#include <dir.h>
#else
	#ifdef __POWERC__
		#include <mem.h>
		#include <dir.h>
	#else
		#ifdef M_I86
			#include <memory.h>
			#include <direct.h>
		#endif
	#endif
#endif

#include "execute.h"

/**************************************************************************
 *  Execute Command - Performs the command line "exec" option.  system() is
 *					  used to execute the command so that the command my be
 *					  a .BAT file.
 *************************************************************************/
void
ExecuteCommand (char *ThisN) {
	extern char CommandString[];

	char Command[250], Dire[65], Name[9];
	char *q, *p1, *p2;
	int n;

	strcpy(Command, CommandString);
	n = 0;
	while ( (q = strchr(&Command[n], '%')) != NULL) {
		switch(toupper(q[1])) {
			case 'F':
				p1 = strrchr(ThisN, '\\');
				Replace(q, 2, ++p1);
				break;
			case 'P':
				Replace(q, 2, ThisN);
				break;
			case 'N':
				p1 = strrchr(ThisN, '\\');
				p2 = strchr(++p1, '.');
				strncpy(Name, p1, p2 - p1); Name[p2 - p1] = '\0';
				Replace(q, 2, Name);
				break;
			case 'E':
				p1 = strrchr(ThisN, '.');
				Replace(q, 2, ++p1);
				break;
			case 'D':
				p1 = strrchr(ThisN, '\\');
				strncpy(Dire, ThisN, --p1 - ThisN); Dire[p1 - ThisN] = '\0';
				Replace(q, 2, Dire);
				break;
			}
		n = q - Command + 2;
		}
	system(Command);
	}

/**************************************************************************
 * Replace - Replaces a number of characters equal to the length of Str2
 *			 in Str1 with the contents of Str2.  The position is Str1 is
 *			 specified by n.
 *************************************************************************/
void
Replace (char *Str1, int n, char *Str2) {
	int	l, r;

	l = strlen(Str1);
	r = strlen(Str2);
	memmove(&Str1[r], &Str1[n], l - n + 1);
	strncpy(Str1, Str2, r);
	}
